<?php
//v 2.0.2

//Admin-Settings Lucente Tab for similar_ideas module.
function similar_ideas_admin($arguments) {		
	switch ($arguments) {
		case 'lucene':						
			$content = similar_ideas_adminlucene();
			break;
		case 'relations':
			$content = similar_ideas_adminrelations();
			break;
		case 'viewall':
			$content = similar_ideas_adminview();
			break;
		case 'search_types':
			$content = similar_ideas_searchtypes();
			break;
	}
	
	return $content;
}





//Admin-Settings Lucene Config tab for similar_ideas module.
function similar_ideas_adminlucene() {			
	$content = "<div>This is the page to configure all the Similar Ideas module settings.</div>";
	$content .= build_luceneform();
	return $content;
}

//Admin-Settings Relationships types tab for similar_ideas module.
function similar_ideas_adminrelations() {	
	global $base_path;		
	$content = "<div>In this page you can edit and delete existing relationship types or create your custom ones.";
	$fields = get_relation_fields();
	
	
	foreach ($fields as $field){
		$name = substr($field, 15);
		$conf ="<span><a href='".$base_path."?q=admin/content/node-type/idea/fields/field_relation_".$name."/configure'>configure</a></span>";
		$del = "<span><a href='".$base_path."?q=admin/content/node-type/idea/fields/field_relation_".$name."/remove'>remove</a></span>";	
		$rows[] = array(check_plain(ucfirst($name)),$conf,$del); 
	}
	$header = array("Current relationships types:","","");
	$content .= theme('table', $header, $rows);
	$content .= "<br>";
	$content .= "<fieldset><legend>Add new relationship type</legend>";
	$content .= build_fieldsform();
	
	$content .= "</div>";
	return $content;
}



function viewallrelations($relation){
  $data_nid = "";

  $fieldnid = 'field_relation_'.$relation.'_nid';
  $result = db_query("SELECT nid,delta,field_relation_".$relation."_nid FROM content_field_relation_".$relation." ORDER BY nid, delta ASC");
  $rows = array();
  $header = array("Idea", "Delta", "Related with");
  while ($data = db_fetch_object($result)){ 
	if ($data->$fieldnid){
		if ($data_nid != $data->nid){
			$rows[] = array(check_plain($data->nid),check_plain($data->delta),check_plain($data->$fieldnid));  
			$data_nid = $data->nid;
		}else $rows[] = array("",check_plain($data->delta),check_plain($data->$fieldnid)); 
	}
  }
  return theme('table', $header, $rows);
}

//Admin-Settings Search Types tab for similar_ideas module.
function similar_ideas_searchtypes() {
	global $base_path;		
	$content = "<div>In this page you can create, configure and delete the different similarity types you can use with the similarity module.";
	
	$result = db_query("SELECT * FROM similar_ideas_searchtypes");
	$dist = "";
	while ($data = db_fetch_object($result)){ 
		if ($data->id > 1){
			$editlink = "<a href='".$base_path."?q=admin/settings/similar_ideas_editsearch/".$data->id."'>Edit</a>";
			$deletelink = "<a href='".$base_path."?q=admin/settings/similar_ideas_deletesearch/".$data->id."'>Delete</a>";
			$dist = "(<font color='green'>".$data->distance."</font>)";
		}
		$rows[] = array($data->name,$data->type." ".$dist,$editlink,$deletelink);	
	}
	
	$header = array("Search name","Type of similarity (Distance)","","");
	$content .= theme('table', $header, $rows);
	$content .= "<br>";
	
	$content .= "<fieldset><legend>".t('Add new similarity type')."</legend>";
	$content .= build_searchtypeform();
	
	$content .= "</div>";
	
	return $content;
}


//Form with the elements for the module config.
function luceneform($form_state){
	//Getting all stored values for setting defaults.
	$ndisplayed = variable_get('similar_ideas_ndisplayed', '5');
	$afteredit = variable_get('similar_ideas_afteredit', '1');
	$aftercreate = variable_get('similar_ideas_aftercreate', '1');
	$fulltree = variable_get('similar_ideas_fulltree', '1');
	
	$form['displayed'] = array(
	  '#type' => 'textfield',	 
	  '#title' => t('Number of similarities to display'),
	  '#default_value' => $ndisplayed,	  
	  '#suffix' => "</ul><br>",
	  '#description' => t('Allowed values 1-20. Default: 5'),
	  '#size' => 5,
	  '#maxlength' => 2,
	  '#required' => TRUE,
	);
	$form['aftercreate'] = array(
  	  '#type' => 'checkbox',
  	  '#title' => t('Show page with similarities after every idea created'),
	  '#description' => t('If enabled, after creating an idea, page showing similarities will be displayed.'),
	  '#return_value' => '1',
	  '#default_value' => $aftercreate,
	);
	$form['afteredit'] = array(
  	  '#type' => 'checkbox',
  	  '#title' => t('Show page with similarities after one idea edited'),
	  '#description' => t('If enabled, after editing an idea, page showing similarities will be displayed.'),
	  '#return_value' => '1',
	  '#default_value' => $afteredit,
	);
	/*$form['fulltree'] = array(
	  '#prefix' => '<br>',
  	  '#type' => 'checkbox',
  	  '#title' => t('Index all parents terms of the taxonomy tree'),
	  '#description' => t('If enabled, for every term index for searching, also all of it\'s parents will be index too.<br><strong>Note:</strong> Remember to Re-Index if you want to apply this configuration in previous content.'),
	  '#return_value' => '1',
	  '#default_value' => $fulltree,
	);	*/
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => t('Save Configuration'),	  
	);
	$form['restore'] = array(
		  '#type' => 'button',	   
		  '#value' => t('Restore defaults'),	 
		  '#executes_submit_callback' => TRUE,
		  '#submit' => array('adminmainform_restore'),
	);
	return $form;
}

function build_luceneform() {  
	return drupal_get_form('luceneform');
}

function luceneform_validate($form, &$form_state) {
  $ndisplayed = $form_state['values']['displayed'];
  if ($ndisplayed < 1 || $ndisplayed > 20) {
    form_set_error('', 'Number of similarities to display must be between 1 and 20.');
  }
}

function luceneform_submit($form, $form_state) {
	$ndisplayed = $form_state['values']['displayed'];
	variable_set('similar_ideas_ndisplayed', $ndisplayed);	
	$afteredit = $form_state['values']['afteredit'];
	variable_set('similar_ideas_afteredit', $afteredit);
	$aftercreate = $form_state['values']['aftercreate'];
	variable_set('similar_ideas_aftercreate', $aftercreate);
	$fulltree = $form_state['values']['fulltree'];
	variable_set('similar_ideas_fulltree', $fulltree);
	drupal_goto("admin/settings/similar_ideas");
}

function adminmainform_restore($form, $form_state) {	
	variable_set('similar_ideas_ndisplayed', '5');
	variable_set('similar_ideas_afteredit', '1');
	variable_set('similar_ideas_aftercreate', '1');
	variable_set('similar_ideas_fulltree', '1');
	drupal_goto("admin/settings/similar_ideas");
}



//Form with the elements for the add field form.
function fieldsform($form_state){	
	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => 'Relationship name',
	  '#default_value' => '',	  	
	  '#size' => 15,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#description' => 'Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4 ',
	  '#required' => TRUE,
	);
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Add relationship type',	  
	);
	return $form;
}


function build_fieldsform() {  
	return drupal_get_form('fieldsform');
}

function fieldsform_validate($form, $form_state){
	$name = $form_state['values']['name'];
	if (strlen($name) < 4) form_set_error('', 'The minimum lenght allowed is 4 characters.');
	if (!ereg("^[a-zA-Z0-9\-_]{4,20}$", $name)) form_set_error('', 'Change name according to allowed characters: _;a-z;A-Z;0-9.');
	if (!ereg("^[a-zA-Z]{3}", $name)) form_set_error('', 'Name should start with a minimum of 3 letters');
	
	$fields = get_relation_fields();
	foreach ($fields as $field){
		if (strtolower($name) == substr($field, 15)) form_set_error('', 'This name is already used as a relationship type, please use a different one.');;
	}
}

function fieldsform_submit($form, $form_state){	
	$name =strtolower($form_state['values']['name']);
	include('similar_ideas.fields.inc');	
	$field = getField($name);
	module_load_include('inc', 'content', 'includes/content.crud');
	content_field_instance_create($field);
	drupal_goto("admin/settings/similar_ideas/relations");
}

//Form with the elements for the add field form.
function searchtypeform($form_state){	

	$subtree = taxonomy_get_vocabularies($type = 'idea');
	$options = array();
	$options['all'] = t('All Vocabularies');
	foreach ($subtree as $voc){
		$options[$voc->vid]= $voc->name;
	}
	
	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => t('Search Name'),
	  '#default_value' => '',	  	
	  '#size' => 25,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#description' => t('Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4'),
	  '#required' => TRUE,
	);
	$form['type'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Type",
		 '#options' => array('none' => t('--Select type--'), 'taxonomy' => t('Taxonomy Search'), 'mixed' => t('Mixed Search')),	
		 '#required' => TRUE,
		);
	$form['distance'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>".t('Distance'),
		 '#options' => array(0 => 0,1 => 1,2 => 2,3 => 3,4 => 4,5 => 5,6 => 6,7 => 7,8 => 8,9 => 9),	
		 '#required' => TRUE,
		);	
	$form['subtree'] = array(
		 '#prefix' => "<br>",
		 '#sufix' => "",
		 '#type' => 'select',		 
		 '#title' => t("Taxonomy Subtree"),
		 '#multiple' => FALSE,
		 '#default_value' => 'none',
		 '#options' => $options,
		 '#size' => 7,
		 '#required' => TRUE,
		);
	
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => t('Add similarity type'),	  
	);
	return $form;
}


function build_searchtypeform() {  
	return drupal_get_form('searchtypeform');
}

function searchtypeform_validate($form, $form_state){
	$name = $form_state['values']['name'];
	$distance = $form_state['values']['distance'];
	$type = $form_state['values']['type'];
	if (strlen($name) < 4) form_set_error('', t('The minimum lenght allowed for name is 4 characters.'));
	if (!ereg("^[a-zA-Z0-9\-_ ]{4,20}$", $name)) form_set_error('', t('Change name according to allowed characters: _;a-z;A-Z;0-9; ;.'));
	if (!ereg("^[a-zA-Z]{3}", $name)) form_set_error('', t('Name should start with a minimum of 3 letters'));	
	if ($type == 'none') form_set_error('', t('You should select one type.'));
	
}

function searchtypeform_submit($form, $form_state){	
	$name = $form_state['values']['name'];
	$distance = $form_state['values']['distance'];
	$type = $form_state['values']['type'];
	$subtree = $form_state['values']['subtree'];
	if ($type == 'full-text'){
		$distance = 0;
		$subtree = 'none';
	}
	
	$query = db_query("INSERT INTO similar_ideas_searchtypes (name,type,distance,taxonomy_subtree) VALUES ('".$name."','".$type."',".$distance.",'".$subtree."')");
	
}



//Content for editing search type %id
function similar_ideas_editsearch($id) {
	global $base_path;
	
	if (is_numeric($id) && $id > 1){
		$result = db_query("SELECT * FROM similar_ideas_searchtypes WHERE id=".$id);
		$data = db_fetch_object($result);
		if ($data){			
			$content .= build_editform($id,$data);
		}else{
			$content .= t("This is not a valid ID.")."<br>";
			$content .= "Please select a proper one in the <a href='".$base_path."?q=admin/settings/similar_ideas/searchtypes'>administration page</a>";	
		}
	}else {
			$content .= "This is not a valid ID.<br>";
			$content .= "Please select a proper one in the <a href='".$base_path."?q=admin/settings/similar_ideas/searchtypes'>administration page</a>";		
	}
	return $content;
}

//Form to confirm edit Search type
function editform($form_state,$id,$default){	
	
	$subtree = taxonomy_get_vocabularies($type = 'idea');
	$options = array();
	foreach ($subtree as $voc){
		$options[$voc->name]= $voc->name;
	}

	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => 'Search Name',
	  '#default_value' => $default->name,	  	
	  '#size' => 25,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#description' => 'Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4 ',
	  '#required' => TRUE,
	);
	$form['type'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Type",
		 '#default_value' => $default->type,
		 '#options' => array('none' => '--Select type--', 'taxonomy' => 'Taxonomy Search', 'mixed' => 'Mixed Search'),	
		 '#required' => TRUE,
		);
	$form['distance'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Distance",
		 '#default_value' => $default->distance,
		 '#options' => array(0 => 0,1 => 1,2 => 2,3 => 3,4 => 4,5 => 5,6 => 6,7 => 7,8 => 8,9 => 9),	
		 '#required' => TRUE,
		);	
	$form['subtree'] = array(
		 '#prefix' => "<br>",
		 '#sufix' => "",
		 '#type' => 'select',		 
		 '#title' => "Taxonomy Subtree",
		 '#multiple' => FALSE,
		 '#default_value' => $default->taxonomy_subtree,
		 '#options' => 	$options,
		 '#size' => 7,
		 '#required' => FALSE,
		);
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Save',	  
	);	
	$form['cancel'] = array(
	  '#type' => 'button',
	  '#value' => 'Cancel',	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('editsearch_cancel'),
	);	
	return $form;
}


function build_editform($id,$default) {	
	return drupal_get_form('editform',$id,$default);
}


function editform_submit($form, $form_state){
	$id = $form['#parameters']['2'];	
	
	$name = $form_state['values']['name'];
	$distance = $form_state['values']['distance'];
	$type = $form_state['values']['type'];	
	$subtree = $form_state['values']['subtree'];
	
	
	$query = db_query("UPDATE similar_ideas_searchtypes SET name='".$name."', type='".$type."', distance=".$distance.", taxonomy_subtree='".$subtree."' WHERE id=".$id);
	
	drupal_get_messages();
	drupal_set_message("Similarity type properly edited.");
	drupal_goto("admin/settings/similar_ideas/searchtypes");
}


function editsearch_cancel($form) {	
	drupal_get_messages();
	drupal_goto("admin/settings/similar_ideas/searchtypes");
}


//Content for deleting search type %id (confirmation page)
function similar_ideas_deletesearch($id) {	
	$query = db_query("DELETE FROM similar_ideas_searchtypes WHERE id=".$id);
	drupal_get_messages();
	drupal_set_message("Deleted properly.");
	drupal_goto("admin/settings/similar_ideas/searchtypes");
}


