<?php
//v 2.0.2


//Similar ideas main page. Suggestions after creating one idea
function similar_ideas_page($node_id, $type) {
	global $base_path;	
	$nid = $node_id;
	$node_path = $base_path."?q=similar_ideas/".$nid."/";
	$node = node_load($nid, NULL, TRUE);
	
	if ($node) {		
			
			//If relations exist we skip or not the similarities page(according to config checkbox setting)
			$aftereditconfig = variable_get('similar_ideas_afteredit', '1');
			$aftercreateconfig = variable_get('similar_ideas_aftercreate', '1');
			
			if ($aftercreateconfig != 1){ //We skip similarity page if after-create setting disabled
				drupal_goto("node/".$nid);
			}
			if ($aftereditconfig != 1){ //We skip similarity page if after-edit setting disabled
				$actualrels = viewnoderel($node); //Extracting all the relationship of the node
				if ($actualrels) drupal_goto("node/".$nid);
			}
			
			//Page content
			$content = "<div><p><span class='bold'><strong>Title:</strong></span> ".$node->title."</p>";			
			$summary = getSummary($node);			
			$content .= "<p><span class='bold'><strong>Idea Summary:</strong></span> ".$summary."</p></div>";		
			$content .= "<div class='suggestions'>";
			$content .= "<div class='suggs_header'><h3><strong>Suggestions:</strong></h3></div>";
			
			//Check type from search names.
			$searchnames = get_search_names();
			$searchtypes = get_search_typesall();
			
			$clave = array_search($type, $searchnames);	
			
			
			if (!$type) $content .= similar_ideas_entity($searchnames[0],$searchtypes[0][2],$nid, $node_path);
			else if($searchnames[$clave] == $type) $content .= similar_ideas_entity($searchnames[$clave],$searchtypes[$clave][2],$nid, $node_path);
			else {
				$content .= "<div class='error_type'><span class='bold'>[Error]</span>";
				$content .= "You must specify a correct search type.</div>";
				$error = true;
			}
			$content .= "</div>";			
			
	} else {
		$content = "<div class='error_idea'><span class='bold'>[Error]</span><br/>";
		$content .= "You must specify a valid idea.</div>";
	}
	return $content;
}



//Content shown for Entity search TO BE DEVELOPED.
function similar_ideas_entity($searchname,$searchtype,$nid, $node_path) {
	
	$types = get_search_typesall();
	
	foreach ($types as $type){
		if ($type[2] == 'full-text') $items[] = similar_ideas_luceneapi($nid, FALSE);
		if ($type[2] == 'taxonomy') $items[] = similar_ideas_luceneapi($nid, TRUE, $type[3], $type[4]);
		
	}
	
	
	$content .= "<div class='rel_types'>[ ";
		
	$names = get_search_names();	
	$ntypes = 0;
	$type_selected = 0; //Number of the selected type. Will be an index for $items[index]
	$flag = 1; //boolean for type = none, and "bold" in navigation bar
	$all_empty = 1; //boolean: 1 = every similarity types have 0 matches. 0 = matches found for at least 1 similarity type (used for skipping page...)
	
	//Construction of the relationships-navigation bar 
	foreach ($names as $name){
			
		$end = " | ";
		if (($ntypes+1) % 4 == 0) $end = " ]";
		if (($ntypes % 4 == 0) && ($ntypes > 0)) $content .= "<br>[ "; // We make the navigation bar with a max. of 4 elements per line.
		
		$nameinminus = strtolower($name);
		if ($name == $searchname || ($searchname == 'none' && $flag == 1)){
			$pre = "";
			$post = "";
			$flag = 0;
			$type_selected = $ntypes;
		}else{			
			$pre = "<a href='".$node_path.$nameinminus."'>";
			$post = "</a>";
		}
		
		if (sizeof($items[$ntypes]) > 0) $all_empty = 0; //We set $all_empty = 0 if theres no matches for any similarity type.
		
		
		$number = " (".sizeof($items[$ntypes]).")";
		if ($ntypes == sizeof($names)-1) $end = " ]";
		$content .= $pre.ucfirst($name)." Search".$number.$post.$end;
		$ntypes++;
		
	}
	$content .= "</div>";
	
	
	
	if ($all_empty == 1) drupal_goto("node/".$nid);	//We 'skip' these page if no similarities found in any category.
		
	
	drupal_set_message("We have detected some ideas similar to yours! Please help us keep the system in order and mark the relationships.",'status',false);		
	$content .= build_form($items[$type_selected], $nid); //Call to the form. This form have the Similar Ideas + Comboboxes + Buttons.
	return $content;
}




function build_form($items, $nid) {  
	return drupal_get_form('similarideas',$items, $nid);
}

//Generates a form with N-items 
//Every item is one of the similar ideas detected by the LuceneAPI
//For every item one ComboBox is displayed to introduce relationships, the title of the ComboBox is the name+link for the Similar Idea detected.
function similarideas($form_state, $items, $nid){
	$form = array();
	
	$node = node_load($nid);
	$actualrels = viewnoderel($node); //Extracting all the relationship of the node
	
	$options = get_array_options();	 //function inside similar_ideas.module
	
	if($items != NULL){
		foreach ($items as $item) {
			if ($actualrels[$item['node']] != NULL) $defaultvalue = $actualrels[$item['node']];
			else $defaultvalue = '';
			
			$node = node_load($item['node']);
			$title = $node->title;
			$summary = getSummary($node);
			$author = $node->name;
			$created = format_date($node->created);

			$text = "<ul><li><li><a class='tooltip' href='".$item["url"]."'>".$item["title"]."<span class='custom info'><em>".$title."</em>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."</span></a>";	
			$form[$item["node"]] = array(
			 '#prefix' => "",
			 '#sufix' => "</li></ul>",
			 '#type' => 'select',		 
			 '#title' => $text,		 
			 '#default_value' => $defaultvalue,
			 '#options' => $options,
			);
		}	
	}
	$form['save'] = array(
	  '#type' => 'submit',	   
	  '#value' => 'Submit Idea',	  
	);
	
	$form['slash'] = array(
	  '#value' => "<style type='text/css'>.sep{margin-left:5px; margin-right:5px;}</style><span class='sep'><strong> | </strong></span>",
	);
	
	$form['edit'] = array(
		  '#type' => 'button',
	  '#value' => 'Rewrite Idea',	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('similarideas_edit'),
	);
	
	$form['delete'] = array(
		  '#type' => 'button',
	  '#value' => 'Cancel Idea',	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('similarideas_delete'),
	);
	return $form;
}

//Action for edit button 
function similarideas_edit($form) {	
	drupal_get_messages();
	$nid = $form['#parameters']['3'];		
	drupal_goto("node/".$nid."/edit");
}
//Action for delete button 
function similarideas_delete($form) {	
	drupal_get_messages();
	$nid = $form['#parameters']['3'];
	drupal_goto("node/".$nid."/delete");
}


//Storing in the DB: Relations stored in BOTH ideas!!
function similarideas_submit($form, $form_state) {	
	$nid = $form['#parameters']['3'];
	$items = $form['#parameters']['2'];	

	$node = node_load($nid);
	$actualrels = viewnoderel($node); //Extracting all the relationship of the node
	
	$permission = user_access('post relationships without approval', NULL, FALSE);

	foreach ($items as $item) {		
		$relationship = $form_state['values'][$item['node']];
		$destiny_idea = $item['node'];		
		
		$node2 = node_load($destiny_idea);
		
		
		$alreadystored = false;		//boolean to avoid the pending-NONE if relation = new.	
		//Checking for duplicates entrys and remove them.
		if ($actualrels[$destiny_idea]){	
			$alreadystored = true;
			if($permission){ //User can unset relationships without aproval
				//Removing from actual node.
				$field = $node->$actualrels[$destiny_idea];				
				$key = array_search(array('nid' => $destiny_idea), $field);
				unset($field[$key]);
				$node->$actualrels[$destiny_idea] = $field;
			
				//Removing from destiny node.		
				$field = $node2->$actualrels[$destiny_idea];		
				$key = array_search(array('nid' => $nid), $field);
				unset($field[$key]);
				$node2->$actualrels[$destiny_idea] = $field;
			}

		}		
		//Storing the new relationships.
		global $user;			
		$status = "pending";					
		$author = $user->name;
		$reviewer = "NONE";
		$date = time();
		$relation = "NONE";		
		if ($relationship){ // 0 = --Set Relationship-- So nothing to store...
			
			$relation = substr($relationship, 15);

			if($permission){ //User can set relationships without aproval
				$field = $node->$relationship;
				$field[]=array('nid' => $destiny_idea);			
				$node->$relationship = $field;
			
				$field = $node2->$relationship;
				$field[]=array('nid' => $nid);	
				$node2->$relationship = $field;
				
			}						
		}	
		if ($alreadystored && $relation == substr($actualrels[$destiny_idea],15)){ //Relation already stored(approved) introduced
			$reviewer = $author;	
			$status = "same-checked"; //New NONE Relation introduced.
		}	
		if (!$alreadystored && $relation == "NONE"){//New NONE Relation introduced.
			$reviewer = $author;			
			$status = "none-checked"; 
		}
		if($permission) {
			$reviewer = $author;
			$status="approved";	
		}
		
		
		
		//Checking former pending ideas.
		$idea1 = max($nid,$node2->nid);
		$idea2= min($nid,$node2->nid);
		$result = db_query("SELECT id FROM similar_ideas_relations WHERE status='pending' AND (idea1=".$idea1." AND idea2=".$idea2.")");
		$value = db_fetch_array($result);  		
		if ($value['id']) $update = db_query("UPDATE similar_ideas_relations SET status='auto-checked', reviewer='".$author."' WHERE id=".$value['id']);
		
		$result1 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
		node_save($node2);		
	}
	node_save($node);
	drupal_get_messages();	//To remove the 'We have detected some ideas...' message.
	if(!$permission) drupal_set_message("Thank you for your help, your relationships will be queued for aproval.");
	drupal_goto("node/".$nid);
}


//After loading a node calling to this function will return an array with every relations for this node.
//['noderelatedto'] = 'typeofrelation'  (typeofrelation: field_relation_duplicate...)
function viewnoderel($node){	
	$fields = get_relation_fields();
	$out = array();	
	foreach ($fields as $field){
		$stored = $node->$field;
		if($stored){
			foreach ($stored as $store){
				if ($store['nid'] != NULL)	$out[$store['nid']] = $field;
			}
		}
	}
	return $out;	
}
